<?php

namespace NoccyLabs\MessageCatalog;

use PHPUnit\Framework\Attributes\CoversClass;

#[CoversClass(MessageCatalog::class)]
class MessageCatalogTest extends \PHPUnit\Framework\TestCase
{
    public function testCreateCatalog()
    {
        if (file_exists("/tmp/testmsg.db")) unlink("/tmp/testmsg.db");
        
        $catalog = new MessageCatalog("/tmp/testmsg.db");

        $message = new Message(html:"<p>Html</p>", text:"Text");
        $catalog->setMessage("collection", "name", $message);

        $foundMessage = $catalog->getMessage("collection", "name");

        $this->assertEquals($message, $foundMessage);

    }

    public function testEnumeratingMessages()
    {
        if (file_exists("/tmp/testmsg.db")) unlink("/tmp/testmsg.db");
        
        $catalog = new MessageCatalog("/tmp/testmsg.db");

        $message = new Message(html:"<p>Html</p>", text:"Text");
        $catalog->setMessage("test", "a", $message);
        $catalog->setMessage("test", "b", $message);
        $catalog->setMessage("test", "c", $message);

        $foundMessages = $catalog->findMessages("test");

        $this->assertCount(3, $foundMessages);

    }

}
